<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class PromocaoCombinada {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
  
	public function buscaProdPromocao($cdfilial, $dtinicial, $dtfinal, $produtoinicial, $produtofinal, $nrorg, $TMODALIDADE, $MODALIDADE, $CDARVPROD, $TCDARVPROD) {
		$row = array();
		
		$params = array(
     	    ":CDFILIAL"    => (count($cdfilial) != 0) ? implode('_' ,$cdfilial) : "",
     	    ":TCDPRODUTO"  => !is_null($produtoinicial)  ? "N" : "T",
     	    ":PRODINI"     => $produtoinicial,
     	    ":PRODFIM"     => $produtofinal,
     	    ":P_DTINI"     => $dtinicial,
     	    ":P_DTFIM"     => $dtfinal,
     	    ":TMODALIDADE" => $TMODALIDADE,
     	    ":MODALIDADE"  => $MODALIDADE,
     	    ":CDARVPROD"   => $CDARVPROD,
     	    ":TCDARVPROD"  => $TCDARVPROD,
     	    ":P_TCDFILIAL" => (count($cdfilial) != 0) ?  "N" : "T",
     	    ":NRORG"       => $nrorg
 		);
 		
		$rowPai = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO_PAI, $params);
        $rowFilho = array();
        
	 	if($rowPai){
	 		$i = 0;
            
	 		for($j = 0; count($rowPai) > $j; $j++){
		 		$param = array(
		 		    ":CDFILIAL"    => $rowPai[$j]["CDFILIAL"],
		 		    ":CDPRODPAI"   => $rowPai[$j]["CDPRODPAI"],
		 		    ":TIPO"        => $rowPai[$j]["TIPO"],
		 		    ":P_DTINI"     => $dtinicial,
		     	    ":P_DTFIM"     => $dtfinal,
             	    ":MODALIDADE"  => $rowPai[$j]["IDORIGEMVENDA"],
		     	    ":NRORG"       => $nrorg,
             	    ":NRSEQVENDA"  => $rowPai[$j]["NRSEQVENDA"]
		 		);
		 		
		 		$rowFilho[$j] = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO_FILHO, $param);
		 		
		 		$totalVend = 0;
		 		
		 		foreach($rowFilho[$j] as $rowEach){
		     		$totalVend += $rowEach['TOTALVENDFIL'];
		     	}
		     	
		     	for($i = 0; count($rowFilho[$j]) > $i; $i++){
		     		if ($rowPai[$j]["TIPO"] == 2) {
		     		    $paramQT = array(
		 		            ":TIPO"        => $rowPai[$j]["TIPO"],
		 		            ":CDPRODPAI"   => $rowPai[$j]["CDPRODPAI"],
		 		            ':DTENTRVENDA' => substr($rowPai[$j]['DTENTRVENDA'], 0, 10)
		     		    );
		 		        $QTPROD = $this->entityManager->getConnection()->fetchAll(self::GET_QT_PROD_PROM, $paramQT)[0]['NRITEMPROMO'];
		     		}
		     		$rowFilho[$j][$i]['TAXAAFINIDADE'] = $rowFilho[$j][$i]["QUANTPRODFIL"]/$rowPai[$j]['QUANTPRODPAI']*100;
		     		$rowFilho[$j][$i]['LABELFILIAL'] = $rowPai[$j]["CDFILIAL"]." - ".$rowPai[$j]["NMFILIAL"];
		     		$rowFilho[$j][$i]['NRCUPONS'] = $rowPai[$j]['NRCUPONS'];
		     		$rowFilho[$j][$i]['CDARVPROD'] = $rowPai[$j]['CDARVPROD'];
		     		$rowFilho[$j][$i]['NMMODALIDADE'] = $rowPai[$j]['NMMODALIDADE'];
		     		$rowFilho[$j][$i]['DATAENTRADA'] = substr($rowFilho[$j][$i]['DTENTRVENDA'],0,10);
		     		$vlr = round(($totalVend / $rowPai[$j]['NRCUPONS']),2);
		     		$rowFilho[$j][$i]['VLRMEDIOCUP'] = str_replace('.', ',' ,$vlr );
		     		$rowFilho[$j][$i]['LABELPRODPROMOCAO'] = $rowPai[$j]['LABELPRODPROMOCAO']." | "."Nr. de Cupons: ".$rowPai[$j]['NRCUPONS']." | "."Qtde. Vendida: ".(isset($QTPROD) ? round($rowPai[$j]['QUANTPRODPAI']/$QTPROD, 3) : $rowFilho[$j][$i]['QUANTPRODFIL'])." | "."Valor Médio Cupom: ".$rowFilho[$j][$i]['VLRMEDIOCUP']." | "."Nr. da Venda: ".$rowPai[$j]['NRSEQVENDA']." | "."Valor Venda: R$".number_format($rowPai[$j]['TOTALVENDA'], 2, ',', '.');
		     		$rowFilho[$j][$i]['VLRMEDIOCUP'] = "Valor Médio Cupom: ".$rowFilho[$j][$i]['VLRMEDIOCUP'];
		     	}
	 		}
	 	}
	 	else{
	 		return $row;
	 	}
        
	 	for($i = 0; count($rowFilho) > $i; $i++){
	 		for($j = 0; count($rowFilho[$i]) > $j; $j++){
	 		    $row[]= $rowFilho[$i][$j];
	 		}
	 	}
	 	
	    return $row;
	}
	
	const GET_PRODUTO_PAI = "
    SELECT IT.CDPRODUTO AS CDPRODPAI, PR.NMPRODUTO AS NMPRODPAI, '1' AS TIPO, PR.CDARVPROD, PR.CDBARPRODUTO AS CDBARPRODPAI, IT.CDFILIAL, FI.NMFILIAL,
        COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS NRCUPONS, SUM(IT.QTPRODVEND) AS QUANTPRODPAI, 
        SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2)) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS TOTALVENDA,
        0 AS QTVENDIDA, IT.CDPRODPROMOCAO||' - '||PR.NMPRODUTO AS LABELPRODPROMOCAO, IT.NRORG, 
        NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS NMMODALIDADE, 
        O.IDORIGEMVENDA, VE.DTENTRVENDA, IT.NRSEQVENDA 
    FROM ITEMVENDA IT
        JOIN VENDA VE 
            ON IT.CDFILIAL = VE.CDFILIAL
                AND IT.CDCAIXA = VE.CDCAIXA
                AND IT.NRSEQVENDA = VE.NRSEQVENDA
                AND IT.NRORG = VE.NRORG
        JOIN PRODUTO PR
            ON IT.CDPRODUTO = PR.CDPRODUTO
                AND IT.NRORG = PR.NRORG
        JOIN FILIAL FI
            ON IT.CDFILIAL = FI.CDFILIAL
                AND IT.NRORG = FI.NRORG
        LEFT JOIN ORIGEMVENDAFOS O
            ON VE.IDORIGEMVENDA = O.IDORIGEMVENDA
                AND VE.NRORG = O.NRORG
    WHERE IT.CDPRODUTO = IT.CDPRODPROMOCAO
        AND (VE.IDSITUVENDA = 'O')
        AND IT.NRORG = :NRORG
        AND (EXISTS (SELECT ES.CDFILIAL 
                        FROM ITEMVENDAEST ES
                        WHERE (ES.CDFILIAL = IT.CDFILIAL)
                            AND (ES.CDCAIXA = IT.CDCAIXA)
                            AND (ES.NRSEQVENDA = IT.NRSEQVENDA)
                            AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)))
        AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
        AND ((PR.CDPRODUTO BETWEEN :PRODINI AND :PRODFIM) OR (:TCDPRODUTO = 'T'))
        AND ((INSTR(:CDARVPROD, PR.CDARVPROD) <> 0) OR (:TCDARVPROD = 'T'))
        AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) > 0) OR (:TMODALIDADE = 'T'))
    GROUP BY IT.CDFILIAL, FI.NMFILIAL, IT.CDPRODUTO, PR.NMPRODUTO, PR.CDARVPROD, PR.CDBARPRODUTO, IT.CDPRODPROMOCAO, 
            IT.NRORG, O.DSORIGEMVENDA, O.IDORIGEMVENDA, VE.DTENTRVENDA, IT.NRSEQVENDA 
	 
    UNION
    	    
    SELECT IT.CDPRODPROMOCAO AS CDPRODPAI, PR.NMPRODUTO AS NMPRODPAI, '2' AS TIPO, PR.CDARVPROD, PR.CDBARPRODUTO AS CDBARPRODPAI, IT.CDFILIAL, FI.NMFILIAL,
            COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS NRCUPONS, SUM(IT.QTPRODVEND) AS QUANTPRODPAI, 
            SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2)) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS TOTALVENDA,
            COUNT(DISTINCT IT.CDFILIAL||IT.CDCAIXA||IT.NRSEQVENDA||IT.NRSEQPRODCOMIT) AS QTVENDIDA,
            IT.CDPRODPROMOCAO||' - '||PR.NMPRODUTO AS LABELPRODPROMOCAO, IT.NRORG, NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS NMMODALIDADE, 
            O.IDORIGEMVENDA, VE.DTENTRVENDA, IT.NRSEQVENDA 
        FROM ITEMVENDA IT
            JOIN PRODUTO PR
                ON IT.CDPRODPROMOCAO = PR.CDPRODUTO
                    AND IT.NRORG = PR.NRORG
            JOIN VENDA VE 
                ON IT.CDFILIAL = VE.CDFILIAL
                    AND IT.CDCAIXA = VE.CDCAIXA
                    AND IT.NRSEQVENDA = VE.NRSEQVENDA
                    AND IT.NRORG = VE.NRORG
            JOIN FILIAL FI
                ON IT.CDFILIAL = FI.CDFILIAL
                    AND IT.NRORG = FI.NRORG
            LEFT JOIN ORIGEMVENDAFOS O
                ON VE.IDORIGEMVENDA = O.IDORIGEMVENDA
                    AND VE.NRORG = O.NRORG
        WHERE VE.IDSITUVENDA = 'O'
            AND (IT.CDPRODPROMOCAO <> IT.CDPRODUTO)
            AND (IT.CDPRODPROMOCAO IS NOT NULL)
            AND (NOT EXISTS (SELECT ES.CDFILIAL
                    FROM ITEMVENDAEST ES
                    WHERE (ES.CDFILIAL       = IT.CDFILIAL    )
                        AND (ES.CDCAIXA      = IT.CDCAIXA     )
                        AND (ES.NRSEQVENDA   = IT.NRSEQVENDA  )
                        AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)))
            AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
            AND ((PR.CDPRODUTO BETWEEN :PRODINI AND :PRODFIM)  OR (:TCDPRODUTO = 'T'))
            AND ((INSTR(:CDARVPROD, PR.CDARVPROD) <> 0) OR (:TCDARVPROD = 'T'))
            AND IT.NRORG = :NRORG
            AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0) OR (:P_TCDFILIAL = 'T'))
            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) > 0) OR (:TMODALIDADE = 'T'))
    GROUP BY IT.CDFILIAL, FI.NMFILIAL, IT.CDPRODPROMOCAO, PR.NMPRODUTO, PR.CDARVPROD, PR.CDBARPRODUTO, IT.NRORG, 
            O.DSORIGEMVENDA, O.IDORIGEMVENDA, VE.DTENTRVENDA, IT.NRSEQVENDA 
    ORDER BY 6, 2
	";
	
	const GET_PRODUTO_FILHO ="
	SELECT ES.CDPRODUTO AS CDSUBPRODFIL, PR.NMPRODUTO AS NMSUBPRODFIL, PR.CDBARPRODUTO AS CDBARPRODFIL, VE.DTENTRVENDA,IT.QTPRODVEND,
        SUM(ES.QTITVENDAEST) AS QUANTPRODFIL, IT.CDPRODPROMOCAO,
        SUM(TRUNC(ES.VRUNVENDAEST * ES.QTITVENDAEST, 2) - NVL(ES.VRDESITVENDAEST, 0)) AS TOTALVENDFIL, IT.NRORG, 
        NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS NMMODALIDADE
    FROM VENDA VE
        JOIN ITEMVENDA IT
            ON IT.CDFILIAL = VE.CDFILIAL
                AND IT.CDCAIXA = VE.CDCAIXA
                AND IT.NRSEQVENDA = VE.NRSEQVENDA
                AND VE.NRORG = IT.NRORG
        JOIN ITEMVENDAEST ES
            ON IT.CDFILIAL = ES.CDFILIAL
                AND IT.CDCAIXA = ES.CDCAIXA
                AND IT.NRSEQVENDA = ES.NRSEQVENDA
                AND IT.NRSEQUITVEND = ES.NRSEQUITVEND
        JOIN PRODUTO PR
            ON ES.CDPRODUTO = PR.CDPRODUTO
        LEFT JOIN ORIGEMVENDAFOS O
            ON VE.IDORIGEMVENDA = O.IDORIGEMVENDA
                AND VE.NRORG = O.NRORG
    WHERE VE.IDSITUVENDA = 'O'
        AND IT.CDPRODUTO = IT.CDPRODPROMOCAO
        AND IT.CDFILIAL = :CDFILIAL
        AND IT.CDPRODPROMOCAO = :CDPRODPAI
        AND :TIPO = '1'
        AND IT.NRSEQVENDA = :NRSEQVENDA
        AND (EXISTS (SELECT ES.CDFILIAL
                        FROM ITEMVENDAEST ES
                        WHERE (ES.CDFILIAL       = IT.CDFILIAL    )
                            AND (ES.CDCAIXA      = IT.CDCAIXA     )
                            AND (ES.NRSEQVENDA   = IT.NRSEQVENDA  )
                            AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND))) 
        AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
        AND VE.NRORG = :NRORG
        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) > 0))
    GROUP BY ES.CDPRODUTO, PR.NMPRODUTO, PR.CDBARPRODUTO, IT.CDPRODPROMOCAO, IT.NRORG, O.DSORIGEMVENDA, VE.DTENTRVENDA, IT.QTPRODVEND
    
    UNION

    SELECT IT.CDPRODUTO AS CDSUBPRODFIL, PR.NMPRODUTO AS NMSUBPRODFIL, PR.CDBARPRODUTO AS CDBARPRODFIL, VE.DTENTRVENDA, IT.QTPRODVEND,
        SUM(IT.QTPRODVEND) AS QUANTPRODFIL, IT.CDPRODPROMOCAO,
        SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2)) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS TOTALVENDFIL, 
        IT.NRORG, NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS NMMODALIDADE
    FROM ITEMVENDA IT
        JOIN VENDA VE
            ON VE.CDFILIAL = IT.CDFILIAL
                AND VE.CDCAIXA = IT.CDCAIXA
                AND VE.NRSEQVENDA = IT.NRSEQVENDA
                AND VE.NRORG = IT.NRORG
        JOIN PRODUTO PR
            ON IT.CDPRODUTO = PR.CDPRODUTO
        LEFT JOIN ORIGEMVENDAFOS O
            ON VE.IDORIGEMVENDA = O.IDORIGEMVENDA
                AND VE.NRORG = O.NRORG
    WHERE VE.CDFILIAL = :CDFILIAL
        AND VE.IDSITUVENDA = 'O'
        AND IT.CDPRODPROMOCAO = :CDPRODPAI
        AND :TIPO = '2'
        AND IT.NRSEQVENDA = :NRSEQVENDA
        AND (NOT EXISTS (SELECT ES.CDFILIAL
                            FROM ITEMVENDAEST ES
                            WHERE (ES.CDFILIAL       = IT.CDFILIAL    )
                                AND (ES.CDCAIXA      = IT.CDCAIXA     )
                                AND (ES.NRSEQVENDA   = IT.NRSEQVENDA  )
                                AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)))
        AND VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM
        AND VE.NRORG = :NRORG        
        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) > 0))
    GROUP BY IT.CDPRODUTO, PR.NMPRODUTO, PR.CDBARPRODUTO, IT.CDPRODPROMOCAO, IT.NRORG, O.DSORIGEMVENDA, VE.DTENTRVENDA, IT.QTPRODVEND
    ORDER BY 4 DESC";
	
	const GET_QT_PROD_PROM = "
	    SELECT CASE WHEN NVL(SUM(QTPRGRUPPROMOC), 1) = 0 THEN 1 ELSE NVL(SUM(QTPRGRUPPROMOC), 1) END AS NRITEMPROMO
        FROM GRUPROMOCPROD
        WHERE (CDPRODPROMOCAO = :CDPRODPAI)
            AND (:DTENTRVENDA BETWEEN NVL(DTINIVGGRPROMO, :DTENTRVENDA) AND NVL(DTFINVGGRPROMO, :DTENTRVENDA))
            AND (:TIPO = '2')
	";
}
